package com.liang.service;

import com.liang.entity.StaIndirectCosts;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 间接费(StaIndirectCosts)表服务接口
 */
public interface StaIndirectCostsService {
    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaIndirectCosts queryById(Integer id);

    /**
     * 分页查询
     *
     * @param staIndirectCosts 筛选条件
     * @param pageRequest      分页对象
     * @return 查询结果
     */
    Page<StaIndirectCosts> queryByPage(StaIndirectCosts staIndirectCosts, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param staIndirectCosts 实例对象
     * @return 实例对象
     */
    int insert(StaIndirectCosts staIndirectCosts);

    /**
     * 修改数据
     *
     * @param staIndirectCosts 实例对象
     * @return 实例对象
     */
    int update(StaIndirectCosts staIndirectCosts);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 通过主表删除数据
     *
     * @param zb
     * @return
     */
    int deleteByZb(Integer zb);

    /**
     * 批量删除间接费
     *
     * @param zbList
     * @return
     */
    int batchDeleteByZb(List<Integer> zbList);

    /**
     * 批量插入间接费
     *
     * @param expenseList
     * @return
     */
    int insertBatch(List<StaIndirectCosts> expenseList);

    /**
     * 获取间接费列表
     *
     * @return
     */
    List<StaIndirectCosts> getJjfList(Integer zb);

    /**
     * 统计报表（间接费）查询
     *
     * @param xmmc 项目名称
     * @param sqrq 创建起始日期
     * @param jsrq 创建结束日期
     * @return
     */
    List<HashMap<String, Object>> searchIndirectCost(Map map);

}
